#include <numeric>
#include <algorithm>

#include "discount.hpp"
#include "discounts/no_discount.hpp"

Price Discount::calculatePrice(const Products& products) const
{
    auto products_with_new_prices = calculateNewPrices(products);

    return std::accumulate(
        products_with_new_prices.begin(),
        products_with_new_prices.end(),
        Price{ 0 },
        [](const Price& lhs, const Product& rhs) { return lhs + rhs.price(); });
}

Discounts::Discounts()
{
    discounts_.push_back(makeDiscount<NoDiscount>());
}
