#include "ostream_discount.hpp"

#include "discounts/no_discount.hpp"
#include "discounts/percent_discount.hpp"
#include "discounts/one_of_Nth_free_discount.hpp"
#include "discounts/complex_discount.hpp"

OstreamDiscount::OstreamDiscount(std::ostream & ostream)
    : ostream_(ostream)
{
}

void OstreamDiscount::visit(NoDiscount&)
{
    ostream_ << "NoDiscount" << '\n';
}

void OstreamDiscount::visit(PercentDiscount& discount)
{
    ostream_ << "PercentDiscount" << '\n';
    ostream_ << "value: " << discount.value() * 100.0 << "%" << '\n';
}

void OstreamDiscount::visit(OneOfNthFreeDiscount& discount)
{
    ostream_ << "OneOfNthFreeDiscount" << '\n';
    ostream_ << "value: each of " << discount.value() << '\n';
}

void OstreamDiscount::visit(ComplexDiscount& discount)
{
    ostream_ << "ComplexDiscount" << '\n';
    ostream_ << "first:" << '\n';
    discount.first()->accept(*this);
    ostream_ << "second:" << '\n';
    discount.second()->accept(*this);
}
