#include <cassert>

#include "complex_discount.hpp"
#include "discount_visitor.hpp"

ComplexDiscount::ComplexDiscount(DiscountPtr first, DiscountPtr second)
    : first_(first), second_(second)
{
    assert(first_ && second_);
}

void ComplexDiscount::accept(DiscountVisitor& visitor)
{
    visitor.visit(*this);
}

DiscountPtr ComplexDiscount::copy() const
{
    return makeDiscount< ComplexDiscount>(first_->copy(), second_->copy());
}

Products ComplexDiscount::calculateNewPrices(const Products & products) const
{
    return second_->calculateNewPrices(first_->calculateNewPrices(products));
}
