#ifndef COMPLEX_DISCOUNT_HPP
#define COMPLEX_DISCOUNT_HPP

#include <discount.hpp>

#include "no_discount.hpp"

class ComplexDiscount : public Discount
{
public:
    ComplexDiscount() = default;

    ComplexDiscount(DiscountPtr first, DiscountPtr second);

    void accept(DiscountVisitor&) override;
    DiscountPtr copy() const override;

    Products calculateNewPrices(const Products& products) const override;

    auto first() const { return first_; }
    auto second() const { return second_; }

private:
    DiscountPtr first_ = makeDiscount<NoDiscount>();
    DiscountPtr second_ = makeDiscount<NoDiscount>();
};

#endif // COMPLEX_DISCOUNT_HPP