#ifndef ONE_OF_NTH_FREE_DISCOUNT_HPP
#define ONE_OF_NTH_FREE_DISCOUNT_HPP

#include <limits>

#include <discount.hpp>

class OneOfNthFreeDiscount : public Discount
{
public:
    OneOfNthFreeDiscount() = default;

    OneOfNthFreeDiscount(unsigned int value);

    void accept(DiscountVisitor&) override;

    DiscountPtr copy() const;

    Products calculateNewPrices(const Products& products) const override;

    auto value() const { return value_; }

private:
    Products sort(Products) const;

    unsigned int value_ = std::numeric_limits<unsigned int>::max();
};

#endif // ONE_OF_NTH_FREE_DISCOUNT_HPP