#ifndef PERCENT_DISCOUNT_HPP
#define PERCENT_DISCOUNT_HPP

#include <discount.hpp>

class PercentDiscount : public Discount
{
public:
    PercentDiscount() = default;

    PercentDiscount(double value);

    void accept(DiscountVisitor&) override;
    DiscountPtr copy() const override;

    Products calculateNewPrices(const Products& products) const override;

    auto value() const { return value_; }

private:
    double value_ = 0;
};

#endif // PERCENT_DISCOUNT_HPP