#include <fstream>

#include "discounts_factory.hpp"

#include "discount_visitors/discount_reader.hpp"

Discounts DiscountsFactory::read(const FilePath& path) const
{
    DiscountFile file(path);

    Discounts discounts;

    DiscountReader reader(file);

    while (file)
    {
        auto discount = DiscountPtr();

        file >> discount;

        discounts.add(discount);
    }

    return discounts;
}