#include <numeric>
#include <algorithm>

#include "price_calculator.hpp"

Price PriceCalculator::calculatePrice(const Products & products)
{
    return calculatePrice(products, Discounts());
}

Price PriceCalculator::calculatePrice(const Products & products, const Discounts & discounts)
{
    auto compare_op = [&products](const auto& lhs, const auto& rhs)
    {
        return lhs->calculatePrice(products) < rhs->calculatePrice(products); 
    };

    auto it = std::min_element(discounts.begin(), discounts.end(), compare_op);

    return (*it)->calculatePrice(products);
}

