#include "product.hpp"

Price operator*(const Price& price, double scalar)
{
    return Price(price.value() * scalar);
}

Price operator+(const Price& lhs, const Price& rhs)
{
    return Price(lhs.value() + rhs.value());
}

Price operator*(const Price& price, const Count& count)
{
    return Price(price.value() * count.value());
}

Product::Product(ProductType type, Count count, Price price_per_unit)
    : type_(type), count_(count), price_per_unit_(price_per_unit)
{
}
