#include "random_product_scanner.hpp"

#include <random>

Products RandomProductScanner::scan()
{
    Products result;

    auto count = getProductsNumber();

    while (count--)
    {
        result.add(getProduct());
    }

    return result;
}

int RandomProductScanner::getProductsNumber() const
{
    std::random_device rd;
    std::mt19937 gen(rd());
    std::uniform_int_distribution<> dis(1, 20);

    return dis(gen);
}

Product RandomProductScanner::getProduct() const
{
    std::vector<Product> available_products = {
        Product(ProductType{"A"}, 0, 10),
        Product(ProductType{"B"}, 0, 20),
        Product(ProductType{"C"}, 0, 30),
        Product(ProductType{"D"}, 0, 40)
    };

    std::random_device rd;
    std::mt19937 gen(rd());
    std::uniform_int_distribution<size_t> dis_int(0, available_products.size() - 1);
    std::uniform_real_distribution<> dis_real(0, 10);

    auto product = available_products[dis_int(gen)];

    return Product(product.type(), dis_real(gen), product.pricePerUnit());
}
