#include "complex_discount.hpp"

#include "discount_presenter.hpp"

#include "discounts/complex_discount.hpp"

#include <ui/ui_complex_discount.h>

#include "qlist_discount_item.hpp"

#include "discount_visitors/discount_name.hpp"

ComplexDiscountGui::ComplexDiscountGui(const ComplexDiscount& discount, QWidget* parent) :
    QDialog(parent),
    ui(new Ui::ComplexDiscount())
{
    ui->setupUi(this);

    setDiscount(discount.first());
    setDiscount(discount.second());

    connect(ui->discountList, SIGNAL(itemDoubleClicked(QListWidgetItem*)), this, SLOT(listItemDoubleClicked(QListWidgetItem*)));
}


void ComplexDiscountGui::setDiscount(const DiscountPtr & discount)
{
    DiscountName discoutn_name;

    auto qlist_item = new QListDiscountItem(discount, ui->discountList);

    discount->accept(discoutn_name);
    qlist_item->setText(QString::fromStdString(discoutn_name.getLastDiscountName()));

    ui->discountList->addItem(qlist_item);
}


void ComplexDiscountGui::listItemDoubleClicked(QListWidgetItem* item)
{
    auto discount_item = dynamic_cast<QListDiscountItem*>(item);

    assert(discount_item != nullptr);

    DiscountPresenter presenter;

    discount_item->discount()->accept(presenter);
}

